﻿(function($){
	$.fn.procycle = function (opts) {
		var defaults = {
			theme:'theme1',			
			distance:0.4,
			imageWidth:400,
			imageHeight:300,
			slideWidth:1000,
			slideHeight:360,
			left:0,right:0,top:0,
			slidesPerScroll:5,
			speed:500,
			numeric:true,
			nextprev:false,
			autoplay:true,
			autoplayInterval:5000,
			mouse:true,
			shadow:false,
			pauseOnHover:true,	
			style_nextprev:'style1',	
			before:function(procycle){},
			after:function(procycle){}
		};
		var opts = $.extend(defaults, opts);
		var returnArr=new Array();			
		for(var i=0;i<this.length;i++){			
			if(!this[i].procycle){
				this[i].procycle=new CycleSlider(this[i],opts);
				this[i].procycle.initCycle();						
			}					
			returnArr.push(this[i].procycle);			
		}		
		return returnArr.length>1?returnArr:returnArr[0];
	};	
	
	var CycleSlider=function(element,opts){
		var settings=$.extend($.fn.procycle.defaults, opts),
			element=$(element), 
			self=this,
			procycle=element.children('.csc-container'),
			slideItems=procycle.children('.csc-item'),
			slideItemsInner=slideItems.children('.csc-item-inner'),
			slideImage=slideItems.find('img'),
			currentSlide=0,
			targetSlide=0,
			numberSlides=slideItems.length,
			isAnimationRunning=false,
			pause=true;	
			this.current=currentSlide;
			this.length=numberSlides;
			this.initCycle=function(){
				var opts=settings;
					initSlideShow();
					if(opts.nextprev==true){initNextPrev();}		
					if(opts.numeric==true){initNumeric();}
					if(opts.shadow==true){initShadow();}
					if(opts.autoplay==true){runAutoplay();}
			};	
			var imageSize=function(i){
				var opts=settings,
					n=numberSlides,
					w=opts.imageWidth,
					h=opts.imageHeight,
					result;			
					if(i!=0){
						if(opts.theme=='theme1' || opts.theme=='theme4'){
							if(i>0&&i<=Math.ceil((n-1)/2)){
								var is=imageSize(i-1);
									w=0.8*is.width ;
									h=0.8*is.height;									
							}else{
								var sz=imageSize(n-i);
									w=sz.width;
									h=sz.height;
							}
						}else{
							if(i==(n-1)){
								w=opts.imageWidth/0.8;
								h=opts.imageHeight/0.8;
							}else{
								var is=imageSize(i-1);
									w=0.8*is.width;
									h=0.8*is.height;
							}
						}
					}						
				return result={width:w,height:h};
			};	
			var slideShadow=function(i){
				var opts=settings,
					n=numberSlides,
					w=opts.imageWidth,
					h=opts.imageHeight+shadowHeight(i),
					result;						
					if(i!=0){
						if(opts.theme=='theme1' || opts.theme=='theme4'){
							if(i>0&&i<=Math.ceil((n-1)/2)){
								var isd=imageSize(i-1);
										w=0.8*isd.width;
										h=(0.8*isd.height)+shadowHeight(i);											
							}else{
								var sz=slideShadow(n-i);
									w=sz.width;
									h=sz.height;
							}
						}else{
							if(i==(n-1)){
								w=opts.imageWidth/0.8;
								h=(opts.imageHeight/0.8)+shadowHeight(i);
							}else{
								var isd=imageSize(i-1);
									w=0.8*isd.width;
									h=(0.8*isd.height)+shadowHeight(i);
							}
						}
					}
				return result={width:w,height:h};
			};
			var getDistance=function(i){
				var opts=settings,
					ds,result;
				var iz=imageSize(i);
					if(opts.theme=='theme1' || opts.theme=='theme2'){
						ds=iz.width*opts.distance;
					}else{
						ds=iz.height*opts.distance;
					}
				return result={distance:ds};
			};
			var centerPos=function(i){
				var opts=settings;
				var	c=topPos(i-1)+(imageSize(i-1).height-imageSize(i).height)/2;
					if(opts.theme!='theme1'){
						if(i==(numberSlides-1)){
							c=opts.top-((imageSize(i).height-imageSize(0).height)/2);
						}
					}
				return c;
			};
			var topPos=function(i){
				var opts=settings;
				var	t=opts.top;
				var	ds=getDistance(i).distance;			
					if(i!=0){
						if(opts.theme=='theme1'){
							if(i>0&&i<=Math.ceil((numberSlides-1)/2)){								
									t=centerPos(i);
							}else{
								t=topPos(numberSlides-i);
							}
						}else{
							 if(i==(numberSlides-1)){
								if(opts.theme=='theme1' ||opts.theme=='theme2'){
									t=centerPos(i);
								}else{
									t=centerPos(i)-ds;
								}
							}else{
								if(opts.theme=='theme1'|| opts.theme=='theme2'){
									t=centerPos(i);
								}else{
									t=centerPos(i)+ds;
								}
							}
						}
					}				
				return t;
			};
			//Top vertical position for theme 4
			var topVerPos=function(i){
				var opts=settings;
				var	n=numberSlides;
				var	vPos,mod=n%2,endSlide=n/2;
				var	ds=getDistance(i).distance;
					if(i==0){
						if(opts.theme=='theme4'){
							vPos=(opts.slideHeight-opts.imageHeight)/2;
						}
					}else{
						if(opts.theme=='theme4'){
							if(i>0&&i<=Math.ceil((n-1)/2)){
								vPos=topVerPos(i-1)-ds;
								if(mod==0){
									if(i==endSlide){
										vPos=(opts.slideHeight-slideShadow(i).height)/2;
									}
								}
						   }else{
								vPos=opts.slideHeight-topVerPos(n-i)-slideShadow(i).height;							
						   }						
						}
				  }	
				return vPos;	
			};			
			var horizonPos=function(i){
				var opts=settings;
				var	n=numberSlides;
				var	vPos,mod=n%2,endSlide=n/2;
				var	ds=getDistance(i).distance;
					if(i==0){
						if(opts.theme=='theme1' || opts.theme=='theme3'|| opts.theme=='theme4'){
							hPos=(opts.slideWidth-opts.imageWidth)/2;
						}else{
							hPos=opts.left;													
						}
					}else{
						if(opts.theme=='theme1'){
							if(i>0&&i<=Math.ceil((n-1)/2)){
								hPos=horizonPos(i-1)-ds;
									if(mod==0){
										if(i==endSlide){
											hPos=(opts.slideWidth-slideShadow(i).width)/2;
										}
									}
						   }else{
								hPos=opts.slideWidth-horizonPos(n-i)-slideShadow(i).width;
						   }
						}else{
							if(opts.theme=='theme2'){
								if(i==(n-1)){
									hPos=horizonPos(0)-(slideShadow(i).width-slideShadow(0).width)/2-ds;
								}else{
									hPos=horizonPos(i-1)+(slideShadow(i-1).width-slideShadow(i).width)/2+ds;
								}
							}
							if(opts.theme=='theme3' || opts.theme=='theme4' ){
								if(i==(n-1)){
									hPos=horizonPos(0)-(slideShadow(i).width-slideShadow(0).width)/2;
								}else{
									hPos=horizonPos(i-1)+(slideShadow(i-1).width-slideShadow(i).width)/2;
								}
							 }	
						}
					}
				return hPos;
			};
			var setOpacity=function(i){
				var opts=settings,n=numberSlides,opc=1,
					hiddenSlide=n-opts.slidesPerScroll;
					if(hiddenSlide<2){
						hiddenSlide=2;
					}
					if(opts.theme=='theme1' || opts.theme=='theme4' ){
						var s1=(n-1)/2,hs2=hiddenSlide/2,
							lastSlide1=(s1+1)-hs2,lastSlide2=s1+hs2;
							if(i==0){
								opc=1;
							}else{
								opc=1;
								if(i>=lastSlide1&&i<=lastSlide2){opc=0;}
							}
					}else{
						if(i==0){
							opc=1;
						}else{
							opc=1;
							if(!(i<(n-hiddenSlide))){
								opc=0;
							}
						}
					}											
				return opc;
			};		
			var setSlidePos=function(i){
				var pos=new Array(),
					opts=settings,
					n=numberSlides;
					for(var j=0;j<n;j++){
						var sz=slideShadow(j);
							if(opts.theme=='theme1'){
								pos[j]={width:sz.width,height:sz.height,top:topPos(j),
										right:horizonPos(j),opacity:setOpacity(j)};								
							}
							if(opts.theme=='theme2'){
								pos[j]={width:sz.width,height:sz.height,top:topPos(j),
								left:31+horizonPos(j),opacity:setOpacity(j)};								
							}
							if(opts.theme=='theme3'){
								pos[j]={width:sz.width,height:sz.height,top:7+topPos(j),
								left:horizonPos(j),opacity:setOpacity(j)};	
							}		
							if(opts.theme=='theme4'){
								pos[j]={width:sz.width,height:sz.height,top:topVerPos(j)-6,
										right:horizonPos(j),opacity:setOpacity(j)};
							}			
					 }						
					return pos[i];
				};
				var slidePosition=function(i){
					var cslide=currentSlide;
					var	pos=i-cslide;
						if(i<cslide){
							pos+=numberSlides;
						}
					return pos;
				};
				var setzIndex=function(i){
					var zid,
						n=numberSlides,
						theme=settings.theme;
						if(theme=='theme2' || theme=='theme3'){
							if(i==(n-1)){
								zid=n-1;
							}else{
								zid=n-(2+i);
							}
						}else{
							if(i>=0&&i<=((n-1)/2)){
								zid=(n-1)-i;
							}else{
								zid=i-1;
							}
						}
					return zid;
				};
				var MouseOver=function(event){
					var o=settings;
					if(o.autoplay==true && o.pauseOnHover==true){
						stopAutoplay();
					}
				};
				var MouseOut=function(event){
					var o=settings;
					if(o.autoplay==true && o.pauseOnHover==true){
						if(pause==true){runAutoplay();}
					}
				};
				var initSlideShow=function(){
					var opts=settings;
					    n=numberSlides,
					    images=slideImage,
					    itemsinner=slideItemsInner;
						procycle.css({'width':opts.slideWidth+'px','height':opts.slideHeight+'px'})
							.bind('mouseover',MouseOver)
							.bind('mouseout',MouseOut);
							for(var i=0;i<n;i++){
								var item=slideItems.eq(i);
									item.css(setSlidePos(slidePosition(i))).bind('click',slideClick);
									slideItems.eq(slidePosition(i)).css({'z-index':setzIndex(i)});
									itemsinner.eq(i).css(imageSize(slidePosition(i)));																									
									images.eq(i).css(imageSize(slidePosition(i)));																																		
									slideItems.eq(0).addClass('on-top');									
									var opacity=item.css('opacity');
									if(opacity==0){
										item.hide();											
									}else{
										item.show();									
									}								
							}
							if(opts.mouse==true){
								procycle.mousewheel(function(event,delta){
									if(delta>0){
										slidingTo(currentSlide-1,false,true);
										return false;
									}else if(delta<0){
										slidingTo(currentSlide+1,false,true);
										return false;
									}
								});
							}
				};
				var hideItem=function(slide){
					var op=slide.css('opacity');
					if(op==0){slide.hide();}
				};
				var slidingTo=function(index,isStopAutoplay,isPause){
					if(isAnimationRunning==true){return;}
					var opts=settings,
						n=numberSlides;
						if(isStopAutoplay==true){
							stopAutoplay();
						}
						targetSlide=index;
						if(targetSlide==n){
							targetSlide=0;
						}
						if(targetSlide==-1){
							targetSlide=n-1;
						}						
						opts.before(self);		
						if(n>1){	
							slideItems.removeClass('on-top');
						 }					
						animateSlide();				
						pause=isPause;
				};
				var animateSlide=function(){
					var opts=settings,
						n=numberSlides;
						if(isAnimationRunning==true){ return;}
						if(currentSlide==targetSlide){
							isAnimationRunning=false;
							return;
						}
						isAnimationRunning=true;
						if(currentSlide>targetSlide){
							var forward=n-currentSlide+targetSlide,
								backward=currentSlide-targetSlide;
						}else{
							var forward=targetSlide-currentSlide,
								backward=currentSlide+n-targetSlide;
						}
						if(forward>backward){
							dir=-1;
						}else{
							dir=1;
						}
						currentSlide+=dir;
						if(currentSlide==n){
							currentSlide=0;
						}
						if(currentSlide==-1){
							currentSlide=n-1;
						}
						buttonNavState();
						for(var i=0;i<n;i++){
							animateImage(i);
						}
				};
				var animateImage=function(i){
					var opts=settings,
						item=slideItems.eq(i),
						pos=slidePosition(i);
						item.show();
						item.animate(setSlidePos(pos),opts.speed,function(){
							hideItem($(this));
							if(i==numberSlides-1){
								isAnimationRunning=false;
								if(currentSlide!=targetSlide){
									animateSlide();
								}else{
									self.current=currentSlide;														
									opts.after(self);																															
									slideItems.eq(currentSlide).addClass('on-top');									 
									var desc=$('div.csc-item.on-top div.csc-content',item.parent().parent().parent());	
								 	var h_c=desc.height();																	
										desc.css({height:0})
										.animate({ height:h_c},800,'linear');									
									}
								}
							}
						);
					item.css({'z-index':setzIndex(pos)});
					slideImage.eq(i).animate(imageSize(pos),opts.speed);
					slideItemsInner.eq(i).animate(imageSize(pos),opts.speed);
					if(opts.shadow==true){
						animateShadow(opts,item,i);
					}
				};
				var slideClick=function(event){
					var $this=$(this);						
					if($this.index()!=currentSlide){							
							slidingTo($this.index(),false,true);								
						return false;
					}
				};
				var shadowHeight=function(p){
					var sh=0;
					if(settings.shadow==true){
						sh=0.12*imageSize(p).height;
					}
					return sh;
			    };
			    var shadowCenterWidth=function(p){
				    var w,s=slideItems.eq(p).find('.csc-shadow'),
					    sLeft=s.children('.csc-shadow-left'),
				        sRight=s.children('.csc-shadow-right'),
				     	sCenter=s.children('.csc-shadow-center');																		
				    return w=imageSize(p).width-(sLeft.width()+sRight.width());
			    };
			    var initShadow=function(){
				    var items=slideItems;
				        n=numberSlides;
						sWidth=imageSize(0).width;
						sInner ='<div class="csc-shadow-left"></div>'+
								'<div class="csc-shadow-center"></div>'+
								'<div class="csc-shadow-right"></div>';
						if(settings.theme!='theme1'){
							sWidth=imageSize(n-1).width;
						}
					for(var i=0;i<n;i++){
						var item=items.eq(i);
							$('<div class="csc-shadow"></div>')
								.css({'width':sWidth+'px'})
								.append(sInner).appendTo(item).children('div');
							item.find('.csc-shadow')
								.children('.csc-shadow-center')
								.width(shadowCenterWidth(i));
					}
		        };
			    var animateShadow=function(option,item,i){
					item.find('.csc-shadow').children('.csc-shadow-center')
						.animate({'width':shadowCenterWidth(slidePosition(i))+'px'},option.speed);
			    };
			    var initNextPrev=function(){
					var el=element, opts=settings;
						el.append('<div class="csc-next '+opts.theme+' '+opts.style_nextprev+'"></div><div class="csc-prev '+opts.theme+' '+opts.style_nextprev+'"></div>');
						el.children('.csc-next')
							.bind('click',function(event){slidingTo(currentSlide+1,false,true);});
						el.children('.csc-prev')
							.bind('click',function(event){ slidingTo(currentSlide-1,false,true);});
			    };
			   var initNumeric=function(){
					var el=element;
					var n=numberSlides;	
						el.append('<div class="csc-pages"></div>');
							var numeric=el.children('.csc-pages');
							for(var i=0;i<n;i++){
								var number=''; number=i+1;
								$('<div class="csc-page '+number+'"></div>')									
									.bind('click',function(event){
										slidingTo($(this).index(),false,true);
									}).appendTo(numeric);
							}
					var b=numeric.children('.csc-page');
						b.eq(0).addClass('active');
						numeric.css({'width':n*b.outerWidth(true),'height':b.outerHeight(true)});
				};
				var buttonNavState=function(){
					var opts=settings,
						numeric=element.children('.csc-pages'),
						button=numeric.children('.csc-page');
						button.removeClass('active');
						button.eq(currentSlide).addClass('active');
				};
				var runAutoplay=function(){
					 var intervalProcess=setInterval(function(){
								slidingTo(currentSlide+1,false,true);
							},
							settings.autoplayInterval
						);
					 element.data('intervalProcess',intervalProcess); 
				};
				var stopAutoplay=function(){
					if(settings.autoplay==true){
						if (element.data('intervalProcess'))
							clearInterval(element.data('intervalProcess'));
					return;
					}
				};
				this.prev=function(){
					slidingTo(currentSlide-1,true,false);
				};
				this.next=function(){
					slidingTo(currentSlide+1,true,false);
				};
				this.slidingTo=function(index){
					slidingTo(index,true,false);
				};
				this.pause=function(){
					stopAutoplay();pause=false;
				};
				this.resume=function(){
					if(settings.autoplay==true){
						runAutoplay();
					}
				};
	};

})($jsmart||jQuery);